#graph server data injection script
# Alice Nodelman
#Usage:
#        -s/--server server_base_name (ie, graphs-stage.mozilla.org) 
#        -p/--path server_path_to_graph (ie, /new-graph) 
#        -b/--bulk for bulk.cgi
#        -c/--collect for collect.cgi
#        -n/--new for sending data to new schema
#Must provide at least a server name and a selection of either bulk, collect or new

import urllib #for conntacting the graph server
import glob
import string
import time    #to set the timer to periodically send info to the graph server
import re
import sys
import os
import getopt
import tempfile
import post_file

def send_New(server, path, cgi):
    #interval,value,pageid
    result_format = "%d,%d,%s\n"
    filename = tempfile.mktemp()
    tmpf = open(filename, "w")
    tmpf.write("START\n")
    tmpf.write("VALUES\n")
    #machine_name,test_name,branch_name,changeset,buildid,date_run
    tmpf.write("graphTester,testMultiValue,Firefox,d5965f522974,20081216131258,%d\n" % int(time.time()))

    i = 0
    while i < 20:
        value = i + 30
        tmpf.write(result_format % (i,value,"NULL"))
        i = i+1
    tmpf.write("END")
    tmpf.flush()
    tmpf.close()
    tmpf = open(filename, "r")
    file_data = tmpf.read()
    print "Testing multiValueAdd\n"
    print file_data
    while True:
      try:
        ret = post_file.post_multipart(server, path + "/" + cgi, [("key", "value")], [("filename", filename, file_data)])
      except IOError:
        print "IOError"
      else:
        break
    lines = ret.split('\n')
    for line in lines:
        print line
    tmpf.close()
    os.remove(filename)

    #test adding a single value instead of a set
    filename = tempfile.mktemp()
    tmpf = open(filename, "w")
    tmpf.write("START\n")
    tmpf.write("AVERAGE\n")
    #machine_name,test_name,branch_name,changeset,buildid,date_run
    tmpf.write("graphTester,testSingleValue,Firefox,d5965f522974,20081216131258,%d\n" % int(time.time()))
    #generate a value, just going to use date as it will guarantee uniqueness
    tmpf.write("%d\n" % int(time.time()))
    tmpf.write("END")
    tmpf.flush()
    tmpf.close()
    tmpf = open(filename, "r")
    file_data = tmpf.read()
    print "Testing singleValueAdd"
    print file_data
    while True:
      try:
        ret = post_file.post_multipart(server, path + "/" + cgi, [("key", "value")], [("filename", filename, file_data)])
      except IOError:
        print "IOError"
      else:
        break
    lines = ret.split('\n')
    for line in lines:
        print line
    tmpf.close()
    os.remove(filename)

def send_Collect(url):
    ret = ''
    testname = "testCollect_name"
    tbox = "tbox_name"
    data = "extra_data"
    i = 0
    date = int(time.time())
    while i < 10:
        value = i*25
        params = urllib.urlencode({'branchid': '2007010905','value': value, 'data': data, 'testname': testname, 'tbox' : tbox, 'time' : i, 'type' : "discrete", 'date' : date, 'branch' : "1.9"})
        # send http-post
        request = urllib.urlopen(url, params)
        ret = request.read()
        i= i+1
    lines = ret.split('\n')
    for line in lines:
        if line.find("RETURN:") > -1:
            print line.rsplit(":")[2] + ":" + line.rsplit(":")[1] 
        else:
            print line

def send_Bulk(server, path, cgi):
    testname = "testBulkAdd"
    tbox = "graphTester"
    data = "extra_data"
    #value, testname, tbox, timeval, date, branch, branchid, type, data
    result_format = "%.2f,%s,%s,%d,%d,%s,%s,%s,%s,\n"
    result_format2 = "%.2f,%s,%s,%d,%d,%s,%s,%s,\n"
    filename = tempfile.mktemp()
    tmpf = open(filename, "w")

    date = int(time.time())
    i = 0
    while i < 20:
        value = i + 30
        tmpf.write(result_format % (value, testname, tbox, i, date, "1.9", "20070303", "discrete", "ms"))
        i = i+1
    i = 0
    tbox = "tbox_2"
    timeval = int(time.time())
    while i < 10:
        value = i*2.5
        tmpf.write(result_format2 % (value, testname, tbox, timeval, date, "1.8", "20070404", "continuous"))
        i = i+1
        timeval = timeval + 600
    tmpf.flush()
    tmpf.close()
    tmpf = open(filename, "r")
    file_data = tmpf.read()
    print file_data
    while True:
      try:
        ret = post_file.post_multipart(server, path + "/" + cgi, [("key", "value")], [("filename", filename, file_data)])
      except IOError:
        print "IOError"
      else:
        break
    lines = ret.split('\n')
    for line in lines:
        if line.find("RETURN:") > -1:
            print line.rsplit(":")[3] + ":" + line.rsplit(":")[1] + ":" + line.rsplit(":")[2] 
        else:
            print line
    tmpf.close()
    os.remove(filename)

usage = "Usage:\n" +  \
        "-s/--server \tserver_base_name (ie, graphs-stage.mozilla.org) \n" +  \
        "-p/--path \tserver_path_to_graph (ie, /server) \n" + \
        "-b/--bulk \tfor bulk.cgi\n" + \
        "-c/--collect\tfor collect.cgi" + \
        "-n/--new\tfor new schema"
sendCGI = ''
server = ''
path = ''
type = 0

try:
    opts, args = getopt.getopt(sys.argv[1:], "bchns:p:", ["server=", "path=", "bulk", "collect", "new", "help"])
except getopt.error, msg:
    print msg
    print "for help use --help"
    sys.exit(2)
for o,a in opts:
    if o in ("-h", "--help"):
        print usage
        sys.exit(1)
    if o in ("-s", "--server"):
        server = a
    if o in ("-p", "--path"):
        path = a
    if o in ("-b", "--bulk"):
        sendCGI = "bulk.cgi"
    if o in ("-c", "--collect"):
        sendCGI = "collect.cgi"
        type = 1
    if o in ("-n", "--new"):
        sendCGI = "collect.cgi"
        type = 2
if (sendCGI == ''):
    print "Must select bulk, collect or new.  For help use --help"
    sys.exit(1)
if (server == ''):
    print "Must select server.  For help use --help"
    sys.exit(1)

if type == 0:
    send_Bulk(server, path, sendCGI)
if type == 1:
    send_Collect("http://%s%s/%s" % (server, path, sendCGI))
if type == 2:
    send_New(server, path, sendCGI)
